/**
 * @file
 * Script for the mediaflow image/video selector
 */
(function ($) {
  "use strict";

  $('#remove-mediaflow-button').on('click', function(){
    $(this).parents('.mediaflow-widget-wrapper-file').find("[data-mediaflow-target]").val(0);
    $(this).parents('.field--type-mediaflow-item').find("img").remove();
    $(this).parents('.field--type-mediaflow-item').find(".plyr").remove();
    $(this).parents('.field--type-mediaflow-item').find(".mediaflow-video").remove();
    $(this).parents('.field--type-mediaflow-item').find('#remove-mediaflow-button').hide();
  });

  $('#pick-mediaflow-button').click(function(){
    var $this = $(this),
    $preview = $this.parents('.field--type-mediaflow-item').find("#mediaflow-file"),
    $input = $this.parents('.field--type-mediaflow-item').find('[data-mediaflow-target]');

    var settings = {};
    $.extend(settings, drupalSettings.mediaflow);
    $.extend(settings, {
      success: function(response) {
        $preview.show();
        $preview.html('');
        $this.parents('.field--type-mediaflow-item').find("img").remove();
        
        if(response.basetype == "video"){
          var mediaElement = document.createElement('div');
          mediaElement.classList = "mediaflow-video";
          mediaElement.innerHTML = response.embedCode;
          $preview.append(mediaElement);
        } else{
          var mediaElement = document.createElement('img');
          mediaElement.setAttribute("src", response.url);
          $preview.append(mediaElement);
        }

        $input
        .val(JSON.stringify(response))
        .trigger('change');

        backDrop.detach();
        modal.detach();
      },
    });

    var fileSelector;
    var backDrop = $('<div />')
      .addClass('mediaflow-ckeditor-backdrop');

    var modal = $('<div />')
      .attr('id', 'mediaflow-ckeditor-modal')
      .addClass('mediaflow-ckeditor-modal');

    var selector = $('<div />')
      .attr('id', 'mediaflow-ckeditor-browser')
      .addClass('mediaflow-ckeditor-browser')
      .appendTo(modal);

    backDrop.click(function () {
      backDrop.detach();
      modal.detach();
    });

    $('body').append(backDrop).append(modal);
    fileSelector = new FileSelector(selector.attr('id'), settings);
  });

  $.fn.mediaFlowBrowser = function () {
    this.each(function () {
      var settings = {};
      var container = $(this);
      var fileSelector;
      $.extend(settings, drupalSettings.mediaflow);
      $.extend(settings, {
        success: function(response) {
          $('[data-mediaflow-target]')
            .val(JSON.stringify(response))
            .trigger('change');
          $('[data-drupal-selector="edit-submit"]').click();
        },
      });
      fileSelector = new FileSelector(container.attr('id'), settings);
      $('[data-drupal-selector="edit-submit"]').hide();
    });
  }

  Drupal.behaviors.mediaFlowSelector = {
    attach: function (context) {
      var editor = document.getElementById("mediaflow-file");
      $('[data-mediaflow-selector]', context).once('mediaflow').mediaFlowBrowser();
    }
  }

})(jQuery);
